#include <stdio.h>
#include <CUnit/Basic.h>
#include <string.h>
#include "calc.h"
#include "calcPrive.h"



int init_suite_success(void) { 
  return 0; 
}

int clean_suite_success(void) { 
  return 0; 
}

void test_estChifre1(void){
  CU_ASSERT_TRUE(CALC_estUnChiffre('1'));
}

void test_estChiffre2(void){
  CU_ASSERT_FALSE(CALC_estUnChiffre('a'));
}

void test_estUneParentheseOuvrante1(void){
  CU_ASSERT_TRUE(CALC_estUneParentheseOuvrante('('));
}

void test_estUneParentheseOuvrante2(void){
  CU_ASSERT_FALSE(CALC_estUneParentheseOuvrante('{'));
}

void test_estUneParentheseFermante1(void){
  CU_ASSERT_TRUE(CALC_estUneParentheseOuvrante('('));
}

void test_estUneParentheseFermante2(void){
  CU_ASSERT_FALSE(CALC_estUneParentheseOuvrante('{'));
}

void test_reconnaitreVirgule1(void){
  unsigned int fin;
  int ok;
  CALC_reconnaitreVirgule("12.1",2,&fin,&ok);
  CU_ASSERT_TRUE((fin==3) && (ok));
}

void test_reconnaitreVirgule2(void){
  unsigned int fin;
  int ok;
  CALC_reconnaitreVirgule("12,1",2,&fin,&ok);
  CU_ASSERT_TRUE((fin==3) && (ok));
}

void test_reconnaitreVirgule3(void){
  unsigned int fin;
  int ok;
  CALC_reconnaitreVirgule("12",2,&fin,&ok);
  CU_ASSERT_TRUE(!ok);
}

void test_reconnaitreSuiteChiffres1(void){
  unsigned int fin;
  int ok;
  CALC_reconnaitreSuiteChiffres("123",0,&fin,&ok);
  CU_ASSERT_TRUE((fin==3) && (ok));
}

void test_reconnaitreSuiteChiffres2(void){
  unsigned int fin;
  int ok;
  CALC_reconnaitreSuiteChiffres("0123",0,&fin,&ok);
  CU_ASSERT_TRUE((fin==4) && (ok));
}

void test_reconnaitreSuiteChiffres3(void){
  unsigned int fin;
  int ok;
  CALC_reconnaitreSuiteChiffres("a123",0,&fin,&ok);
  CU_ASSERT_TRUE(!ok);
}

void test_reconnaitreNombre0(void){
  unsigned int fin;
  int ok;
  float nb;
  CALC_reconnaitreNombre("123",0,&nb,&fin,&ok);
  CU_ASSERT_TRUE((fin==3) && (ok) && (nb==123.));
}


void test_reconnaitreNombre1(void){
  unsigned int fin;
  int ok;
  float nb;
  CALC_reconnaitreNombre("123,25",0,&nb,&fin,&ok);
  CU_ASSERT_TRUE((fin==6) && (ok) && (nb==123.25));
}

void test_reconnaitreNombre2(void){
  unsigned int fin;
  int ok;
  float nb;
  CALC_reconnaitreNombre("0123.25",0,&nb,&fin,&ok);
  CU_ASSERT_TRUE((fin==7) && (ok) && (nb==123.25));
}

void test_reconnaitreNombre3(void){
  unsigned int fin;
  int ok;
  float nb;
  CALC_reconnaitreNombre("123.",0,&nb,&fin,&ok);
  CU_ASSERT_TRUE((fin==4) && (ok) && (nb==123.));
}

void test_reconnaitreNombre4(void){
  unsigned int fin;
  int ok;
  float nb;
  CALC_reconnaitreNombre(".25",0,&nb,&fin,&ok);
  CU_ASSERT_TRUE((fin==3) && (ok) && (nb==.25));
}

void test_reconnaitreOperateur1(void){
  unsigned int fin;
  int ok;
  CALC_Operateur op;
  CALC_reconnaitreOperateur("+",0,&op,&fin,&ok);
  CU_ASSERT_TRUE((fin==1) && (ok) && (op==addition));
}

void test_reconnaitreOperateur2(void){
  unsigned int fin;
  int ok;
  CALC_Operateur op;
  CALC_reconnaitreOperateur("-",0,&op,&fin,&ok);
  CU_ASSERT_TRUE((fin==1) && (ok) && (op==soustraction));
}

void test_reconnaitreOperateur3(void){
  unsigned int fin;
  int ok;
  CALC_Operateur op;
  CALC_reconnaitreOperateur("*",0,&op,&fin,&ok);
  CU_ASSERT_TRUE((fin==1) && (ok) && (op==multiplication));
}

void test_reconnaitreOperateur4(void){
  unsigned int fin;
  int ok;
  CALC_Operateur op;
  CALC_reconnaitreOperateur("/",0,&op,&fin,&ok);
  CU_ASSERT_TRUE((fin==1) && (ok) && (op==division));
}

void test_reconnaitreOperateur5(void){
  unsigned int fin;
  int ok;
  CALC_Operateur op;
  CALC_reconnaitreOperateur("#",0,&op,&fin,&ok);
  CU_ASSERT_TRUE(!ok);
}

void test_reconnaitreOperande1(void){
  unsigned int fin;
  int ok;
  float nb;
  CALC_reconnaitreOperande("125",0,&nb,&fin,&ok);
  CU_ASSERT_TRUE((fin==3) && (ok) && (nb=125.));
}

void test_reconnaitreOperande2(void){
  unsigned int fin;
  int ok;
  float nb;
  CALC_reconnaitreOperande("(125+24.25)",0,&nb,&fin,&ok);
  CU_ASSERT_TRUE((fin==11) && (ok) && (nb=149.25));
}

int main(int argc, char** argv){
  CU_pSuite pSuite = NULL;

  /* initialisation du registre de tests */
  if (CUE_SUCCESS != CU_initialize_registry())
    return CU_get_error();

  /* ajout d'une suite de test */
  pSuite = CU_add_suite("Test tri par tas (boite noire)", init_suite_success, clean_suite_success);
  if (NULL == pSuite) {
    CU_cleanup_registry();
    return CU_get_error();
  }

  /* Ajout des tests  la suite de tests boite noire */
  if ((NULL == CU_add_test(pSuite, "'1' est un chiffre", test_estChifre1))
      || (NULL == CU_add_test(pSuite, "'a' n'est pas un chiffre", test_estChiffre2))
      || (NULL == CU_add_test(pSuite, "'(' est une parenthese ouvrante", test_estUneParentheseOuvrante1))
      || (NULL == CU_add_test(pSuite, "'{' n'est pas une parenthese ouvrante", test_estUneParentheseOuvrante2))
      || (NULL == CU_add_test(pSuite, "')' est une parenthese fermante", test_estUneParentheseFermante1))
      || (NULL == CU_add_test(pSuite, "'}' n'est pas une parenthese fermante", test_estUneParentheseFermante2))
      || (NULL == CU_add_test(pSuite, "'12.1' a une virgule", test_reconnaitreVirgule1))
      || (NULL == CU_add_test(pSuite, "'12,1' a une virgule", test_reconnaitreVirgule2))
      || (NULL == CU_add_test(pSuite, "'12' n'a pas de virgule", test_reconnaitreVirgule3))
      || (NULL == CU_add_test(pSuite, "'123' est une suite de chiffres", test_reconnaitreSuiteChiffres1))
      || (NULL == CU_add_test(pSuite, "'0123' est une suite de chiffres", test_reconnaitreSuiteChiffres2))
      || (NULL == CU_add_test(pSuite, "'a123' n'est pas une suite de chiffres", test_reconnaitreSuiteChiffres2))
      || (NULL == CU_add_test(pSuite, "'123' represente un nombre", test_reconnaitreNombre0))
      || (NULL == CU_add_test(pSuite, "'123,25' represente un nombre", test_reconnaitreNombre1))
      || (NULL == CU_add_test(pSuite, "'0123.25' represente un nombre", test_reconnaitreNombre2))
      || (NULL == CU_add_test(pSuite, "'123.' represente un nombre", test_reconnaitreNombre3))
      || (NULL == CU_add_test(pSuite, "'.25' represente un nombre", test_reconnaitreNombre4))
      || (NULL == CU_add_test(pSuite, "'+' represente un operateur", test_reconnaitreOperateur1))
      || (NULL == CU_add_test(pSuite, "'-' represente un operateur", test_reconnaitreOperateur2))
      || (NULL == CU_add_test(pSuite, "'*' represente un operateur", test_reconnaitreOperateur3))
      || (NULL == CU_add_test(pSuite, "'/' represente un operateur", test_reconnaitreOperateur4))
      || (NULL == CU_add_test(pSuite, "'#' ne represente pas un operateur", test_reconnaitreOperateur4))
      || (NULL == CU_add_test(pSuite, "'125' represente une operande", test_reconnaitreOperateur1))
      || (NULL == CU_add_test(pSuite, "'(125+24.25)' represente une operande", test_reconnaitreOperateur2))
      )
    {
      CU_cleanup_registry();
      return CU_get_error();
    }

  /* Lancement des tests */
  CU_basic_set_mode(CU_BRM_VERBOSE);
  CU_basic_run_tests();
  printf("\n");
  CU_basic_show_failures(CU_get_failure_list());
  printf("\n\n");

  /* Nettoyage du registre */
  CU_cleanup_registry();
  return CU_get_error();
}
